#ifndef __CLF_DISPATCH__
#define __CLF_DISPATCH__

// this is actually a dispatch base class
// classes derived from this will handle the gameplay depending on game state
class clf_dispatch{
public:
	clf_dispatch(){
	}
	virtual ~clf_dispatch(){
	}
	virtual void window_resize (int width, int height){			// reshape the window when it's moved or resized
	}
	virtual bool graphics_init(){
		return true;
	}
	virtual void graphics_terminate(){
	}
	virtual void frame_move(clFloat fElapsed){
	}
	virtual void frame_render()=0; // it has to handle drawing at least
};

#endif // __CLF_DISPATCH__
