#ifndef __clf_functor__
#define __clf_functor__

// callback mechanism
// functors are handy when we want to use
// objects and pointers to member functions as callbacks

// abstract base class
class clf_functor
{
public:
	// virtual cause derived classes will use a pointer to an object 
	// and a pointer to a member function to make the function call
	virtual void invoke(int option)=0;
};

// derived template class
template <typename T> class clf_functor_inst : public clf_functor
{
	void (T::*fpt)(int);   // pointer to member function
	T* pt2Object;                  // pointer to object

public:
	// constructor - takes pointer to an object and pointer to a member and stores
	// them in two private variables
	clf_functor_inst(T* _pt2Object, void(T::*_fpt)(int)) {
		pt2Object = _pt2Object;
		fpt=_fpt; 
	};

	// override function "Call"
	virtual void invoke(int option) {
		(*pt2Object.*fpt)(option);
	}
};

#endif // __clf_functor__