#include "stdafx.h"
#include "clf_primitives.h"
#include "clf_light.h"


clf_light::clf_light(unsigned int id)
{
	light_id = id;
}

clf_light::~clf_light()
{
}

void clf_light::set_ambient(clFloat a0, clFloat a1, clFloat a2, clFloat a3)
{
	light_ambient[0] = a0; light_ambient[1] = a1; light_ambient[2] = a2; light_ambient[3] = a3;
}

void clf_light::set_diffuse(clFloat a0, clFloat a1, clFloat a2, clFloat a3)
{
	light_diffuse[0] = a0; light_diffuse[1] = a1; light_diffuse[2] = a2; light_diffuse[3] = a3;
}

void clf_light::set_specular(clFloat a0, clFloat a1, clFloat a2, clFloat a3)
{
	light_specular[0] = a0; light_specular[1] = a1; light_specular[2] = a2; light_specular[3] = a3;
}

void clf_light::set_position(clFloat x, clFloat y, clFloat z, clFloat w)
{
	light_position = clf_vector4 (x,y,z,w);
}

clf_vector4& clf_light::position()
{
	return light_position;
}

void clf_light::apply()
{
	glEnable (light_id);						 // and turn on light 0
	// pass them to OpenGL
	glLightfv (light_id, GL_AMBIENT, light_ambient);
	glLightfv (light_id, GL_DIFFUSE, light_diffuse);
	glLightfv (light_id, GL_SPECULAR, light_specular);
	glLightfv (light_id, GL_POSITION, light_position);
}

void clf_light::draw_source()
{
	//glPushAttrib(GL_ALL_ATTRIB_BITS);
	//glDisable(GL_LIGHTING);
	glPushMatrix();

	// Now rotate the jet around in the new flattend space
	glTranslatef(light_position[0],light_position[1],light_position[2]);
	glColor3f(1.0f, 1.0f, .0f);
	drawSphere(3);

	// Restore the projection to normal
	glPopMatrix();
	//glPopAttrib();
}
