#ifndef __CLF_MENU__
#define __CLF_MENU__

#include "clf_dispatch.h"
#include "clf_functor.h"

class clf_menu : public clf_dispatch
{
protected:
	cCamera m_cam;	// menu camera
	clf_stage m_stage;
	clf_light m_light;	// menu light

	int option;
	struct menu_entry{
		std::string entry_text;
		int entry_id;
	};
	std::vector<menu_entry> entries;
	clf_functor* menu_handler;
	clf_font* menu_font;
	BYTE m_key_state[3]; // up, down, enter
	clFloat xpos, ypos, zpos;
	clFloat xstep, ystep, zstep;
public:
	clf_menu();
	virtual ~clf_menu();

	virtual void frame_render();
	virtual void frame_move(clFloat fElapsed);
	virtual bool graphics_init();
	virtual void window_resize (int width, int height);

	void set_pos(clFloat xp, clFloat yp, clFloat zp);
	void set_step(clFloat xs, clFloat ys, clFloat zs);

	void add_option(char* text, int id);
	void set_menu_callBack(clf_functor* pf);
};

#endif // __CLF_MENU__
