#include "stdafx.h"
#include <direct.h>
#include "clf_resources.h"
#include "clf_image.h"

static char base_dir[2000] = "";
static char* resDir[]={ "resources/textures/", "resources/stl/", "resources/3ds/", "resources/shaders/"};
char* get_resource_file_name (const char* name, int resType)
{
	static char outPathName[2048];
	if (strlen(base_dir) == 0)
	{
		_getcwd(base_dir, 2000);
		if (base_dir[strlen(base_dir)-1] != '\\')
			strcat(base_dir, "\\");
	}
	if (name[1] != ':')
		sprintf (outPathName, "%s%s%s", base_dir,resDir[resType], name);
	else
		strcpy(outPathName, name);
	return outPathName;
}

GLuint clf_loadTexture(const char* fname)
{
	GLuint tex = -1;
	clf_targa_image image;
	char real_name[2000];
	strcpy(real_name, get_resource_file_name(fname, RES_TEX));
	if (!image.load(real_name))
	{
		return tex;
	}
	glPushAttrib(GL_ALL_ATTRIB_BITS);

	glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
	glEnable(GL_TEXTURE_2D);

	glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE);
	glGenTextures(1, &tex);
	glBindTexture(GL_TEXTURE_2D, tex);

	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	// when texture area is small, bilinear filter the closest mipmap
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST );
	// when texture area is large, bilinear filter the original
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_PRIORITY, 1.f );

	// the texture wraps over at the edges (repeat)
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );

	gluBuild2DMipmaps(GL_TEXTURE_2D, 4, 
		image.get_width(), image.get_height(), 
		image.get_image_format(), image.get_data_type(), image.get_image());

	glPopAttrib();

	image.release();

	return tex;
}
