/* skybox class that actualy draws the horizon
the whiole world is asumed to be a cube of infinite size
the class needs the textures for the six faces of the cube */
#ifndef __SKYBOX_H_INCLUDED__
#define __SKYBOX_H_INCLUDED__

#include "clf_math.h"

class clf_skybox
{
public:
	clf_skybox(clFloat b_size=2.f);
	~clf_skybox();

	// load the six textures
	bool load_textures(const char* top, const char* bottom, const char* front, const char* back, const char* left, const char* right);
	// after you apply your view tranformations
	// render the skybox
	void render(clFloat cameraX, clFloat cameraY, clFloat cameraZ);

	// call to allow release of internal data upon progrm termination
	void release();

	// call when graphis system is reset (res change)
	void clf_reset();

protected:
	enum {
		SKY_TOP,
		SKY_BOTTOM,
		SKY_EAST,
		SKY_WEST,
		SKY_NORTH,
		SKY_SOUTH
	};

	unsigned int m_textures[6];		// 6 texture objects
	std::string  m_textureNames[6];
	clf_vector3D m_size;
	GLuint    draw_list;
	void      build_draw_list();
};

#endif // __SKYBOX_H_INCLUDED__